% Created 2021-06-01 Tue 19:57
% Intended LaTeX compiler: pdflatex
\documentclass[11pt]{article}
\usepackage[utf8]{inputenc}
\usepackage[T1]{fontenc}
\usepackage{graphicx}
\usepackage{grffile}
\usepackage{longtable}
\usepackage{wrapfig}
\usepackage{rotating}
\usepackage[normalem]{ulem}
\usepackage{amsmath}
\usepackage{textcomp}
\usepackage{amssymb}
\usepackage{capt-of}
\usepackage{hyperref}
\author{Alexander Brown}
\date{}
\title{The Berth Allocation Problem to the Position Allocation Problem}
\hypersetup{
 pdfauthor={Alexander Brown},
 pdftitle={The Berth Allocation Problem to the Position Allocation Problem},
 pdfkeywords={},
 pdfsubject={},
 pdfcreator={Emacs 27.2 (Org mode 9.5)}, 
 pdflang={English}}
\begin{document}

\maketitle
\tableofcontents


\section*{Introduction}
\label{sec:org87e64ff}

\section*{The Berth Allocation Problem (BAP)}
\label{sec:orge517172}
The BAP is a ship allocation problem regarding berth space for vessels in container terminals. As ships arrive, they must be allocated space and time along the berth to be served. Different factors that are taken into account are: time required to serve and size of the vessel. Solutions to BAP make attempts to optimize the space/time allocation for the vessels by

\begin{itemize}
\item Minimization of service time
\item Minimization of early and delayed departures
\item Optimization of arrival times
\item Optimization of emissions and fuel consumption
\end{itemize}

\subsection*{Continuous and Discrete Representation}
\label{sec:org002ecf7}
As with most problems, they can be represented in either a continuous or discrete fashion. Among the models

\begin{enumerate}
\item Discrete vs. continuous berth space
\item Static vs. dynamic vessel arrival
\item Static vs. dynamic vessel handling times
\item Variable vessel arrivals
\end{enumerate}

are observed most frequently in literature. For our purposes, we will mostly be analyzing the discrete berth space with dynamic vessel arrivals.

\subsection*{Static BAP Modeling}
\label{sec:org0f69482}
\subsubsection*{Port and Berth Information}
\label{sec:orgc505d53}
\begin{itemize}
\item \(W\): Number of wharfs
\item \(w_l\) : Length of wharf \(i \in 1,...,W\)
\item \(M\): Number of berths in the terminal
\item \(L_i\): Length of berth \(i \in 1,...,M\)
\end{itemize}

\subsubsection*{Vessel Information}
\label{sec:org91b45f9}
\begin{itemize}
\item \(N\): Number of vessels that have arrive or will arrive within the schedule window
\item \(r_i\): Arrival time of vessel \(i\)
\item \(l_i\): Length of vessel \(i\)
\item \(p_i\): Time to process vessel \(i\)
\end{itemize}

\subsubsection*{Decision Variables}
\label{sec:org730d115}
\begin{itemize}
\item \(x_i\): Berthing location for vessel \(i\)
\item \(t_i\): Planning berthing time for vessel \(i\)
\end{itemize}

\subsubsection*{Cost Variables}
\label{sec:org116a5ed}
\begin{itemize}
\item Location Cost
The quality of the berthing locations assigned are given by
\end{itemize}

\begin{equation}
\sum_{i=1}^{N} c_i (x_i)
\end{equation}

where \(c_i\) is a step function in \(x_i\). Another way to look at this is assume \(c_i(x_i) = d_{i,l}\) where \(d_{i,j}\) is the cost for berthing vessel \(i\) at berth \(l\). \(d_{i,l}\) can then be thought as the desirability of berthing vessel \(i\) at berth \(l\).

\begin{itemize}
\item Delay Cost
The quality of the berthing times assigned is given by
\end{itemize}

\begin{equation}
\sum_{i=1}^{N} w_i(t_i-r_i-2)^+
\end{equation}

In this case, a vessel is considered berthed-on-arrival if it can be berthed within two hours of arrival (hence the \(-2\) in the cost function).

Putting it together we get

\begin{equation}
\begin{array}{cc}
\sum_{i=1}^{N} c_i(x_i) + w_i(t_i-r_i-2)^+ & \\
s.t & t_i \geq r_i \forall i \\
    & x_i + l_i \leq \sum_i L_i, x_i \geq 0 \forall i \\
    & x_i \in W \\
    & t_i + p_i \leq t_j \; \textrm{or}\; t_j + p_j \leq t_i\; \textrm{or}\; x_i + l_i \leq x_j\; \textrm{or}\; x_j + l_j \leq x_j \forall i \neq j \\
\end{array}
\end{equation}

The last constraint models that vessels \(i\) and \(j\) cannot occupy the same location in the terminal at the same time.

\subsection*{Definitions}
\label{sec:orgb596e80}
\begin{itemize}
\item Terminal: The facility where the vessels are docked
\item Wharf: A linear strip where the vessels are able to dock. There are typically multiple wharfs in a terminal
\item Berth: A berth is a discrete subsection of the wharf. There are typically multiple berths in a wharf.
\end{itemize}

\subsubsection*{TODO: Add image from Cornell paper here}
\label{sec:orgdf34972}

\subsection*{Dynamic BAP Model}
\label{sec:org611e46b}
The dynamic BAP model adds the additional challenge of rolling the plan forward every time step. The main problem being is how to handle the situation where a vessel \(j\) is already in the place of vessel \(i\).

An approach to this is to mark used berths as forbidden zones. The schedule is then is readjusted by placing a lower limit to the berthing location decision variable. If there is no room (meaning the vessel must wait), a lower bound can be placed on the time decision variable.

\section*{The Position Allocation Problem (PAP)}
\label{sec:orgdc9d711}
The scenario where buses are lined up to be charged is extremely analogous to the BAP problem. The significant difference is the location of the ``wharf''. Instead of docking the vehicles parallel to the wharf, they will be lined up perpendicular to it. The following describes the conversion from the berth allocation problem to the position allocation problem.

\subsection*{Variable Matching:}
\label{sec:org936677d}

\begin{itemize}
\item \(S\): Length of the berth
\item \(T\): Length of the time horizon
\item \(N\): Total number of incoming vehicles
\item \(p_i\): The charging time for vehicle \(i; \forall 1 \leq i \leq N\)
\item \(s_i\): The size of vehicle \(i; \forall 1 \leq i \leq N\)
\item \(a_i\): The arrival time of vehicle \(i; \forall 1 \leq i \leq N\)
\item \(w_i\): The weight assigned for vehicle \(i; \forall 1 \leq i \leq N\)
\end{itemize}

\subsection*{Decision Variable Matching}
\label{sec:orgfb50086}
\begin{itemize}
\item \(u_i\): The starting time of charging for vehicle \(i; \forall 1 \leq i \leq N\)
\item \(v_i\): The starting berth position occupied by vehicle \(i; \forall 1 \leq i \leq N\)
\item \(c_i\): The departure time of vehicle \(i; \forall 1 \leq i \leq N\)
\item \(\sigma_{ij}\):
\begin{equation*}
\begin{array}{c}
  \sigma_{ij}:\; \begin{cases} 1 & \textrm{ if vehicle i is full on the left of} \\
  & \textrm{vehicle j in the } \\
  & \textrm{Time - space diagram} \\
  0 & \textrm{otherwise} \\
  \end{cases} \\
 \end{array}
 \end{equation*}
\item \(\delta_{ij}\):
\begin{equation*}
\begin{array}{c}
  \delta_{ij}:\; \begin{cases} 1 & \textrm{ if vehicle i is full below} \\
  & \textrm{vehicle j in the } \\
  & \textrm{Time - space diagram} \\
  0 & \textrm{otherwise} \\
 \end{cases}\\
 \end{array}
 \end{equation*}
\end{itemize}

\subsection*{Formulation}
\label{sec:orgcc3b0d3}
The cost function is of the form
\begin{equation}
min \sum_{i=1}^N w_i(c_i - a_i)
\end{equation}

Subject to the constraints

\begin{equation}
\begin{array}{cc}
u_j - u_i - p_i - (\sigma_{ij} - 1)                          & T \geq 0 \\
v_j - v_i - s_i - (\delta_{ij} - 1)                          & S \geq 0 \\
\sigma_{ij} + \sigma_{ji} + \delta_{ij} + \delta_{ji} \geq 1 & \\
\sigma_{ij} + \sigma_{ji} \leq 1                             & \\
\delta_{ij} + \delta_{ji} \leq 1                             & \\
p_i + u_i = c_i                                              & \\
a_i \leq u_i \leq (T-p_i)                                    & \\
\sigma_{ij} \in \{0,1\},\; \delta_{ij} \in \{0,1\} \\
\end{array}
\end{equation}

The first and second constraint are the definition of \(\sigma\) and \(\delta\), respectively. The fourth constraint through the sixth guarantee that vehicle \(i\) and \(j\) do not overlap in the Time-Space diagram. Constraint seven shows the relationship between the completion time \(c_i\) and the starting time \(u_i\) for vehicle \(i\). Constraints eight and nine define the feasible domains for the decision variables \(u_i\), \(v_i\), \(\sigma_{ij}\), and \(\delta_{ij}\).

\subsubsection*{The Time-Space Diagram}
\label{sec:orgd2f1edb}
The first and second constraint (\(\sigma_{ij}\) and \(\delta){ij}\)) are represented in the figure below. \(\sigma{ij}\) represents vehicle \(i\) being charged and allowing \(j\) to take its place to be charged (i.e. if the vehicle in front of me is charged \(\sigma_{ij} = 1\)). \(\delta{ij}\) represents the vehicles being lined up perpendicular to their respective charging stations (i.e. the vehicle in the charging lane to my left is done therefore \(\delta_{ij} = 1\)).

![Berth Allocation Time-Space Diagram](img/BerthTimeSpace.gif)

\section*{Fuzzy BAP}
\label{sec:org3154a33}
\subsection*{Preliminaries}
\label{sec:org92bddd8}
\subsubsection*{Fuzzy Sets}
\label{sec:org349ce33}
\begin{equation}
    \tilde{A} = \{ (x, \mu_{\tilde{A}}(x), x \in X) \}
\end{equation}

Where \(\mu_{\tilde{A}} : X \rightarrow [0,1]\) is called the membership function.

\subsubsection*{Triangular Fuzzy Number}
\label{sec:org1d5108d}
\begin{equation}
\tilde{a} = (a_1, a_2, a_3)
\end{equation}

\begin{center}
\includegraphics[width=.9\linewidth]{./img/TriangularFuzzyNumber.png}
\end{center}

\subsubsection*{Fuzzy Arithmetic}
\label{sec:org30a7ed7}
If we have two fuzzy numbers \(\tilde{a}\) and \(\tilde{b}\) then the sum is taken as

\begin{equation}
\tilde{a} + \tilde{b} = (a_1 + b_1, a_2 + b_2, a_3 + b_3)
\end{equation}

And similarly is done for the difference.

\subsubsection*{Comparison of Fuzzy Numbers}
\label{sec:org625c984}
There are multiple ways of comparing fuzzy numbers, the way done in this particular text is the First Index of Yagger

\begin{equation}
\mathbb{R} = \frac{a_1 + a_2 + a_3}{3}
\end{equation}

Which results in \(\tilde{a} \leq \tilde{b}\) when \(\mathbb{R}(\tilde{a}) \leq \mathbb{R}(\tilde{b})\)


\subsection*{Formulation of Fully Fuzzy Linear Programs}
\label{sec:org86e37ed}

\begin{equation}
\begin{array}{cc}
\sum_{j=1}^n \tilde{c}_j \tilde{x}_j & \\
s.t. & \sum_{j=1}^n \tilde{a}_{ij} \tilde{x}_j \leq \tilde{b}_j \\
\end{array}
\end{equation}

As a consequence of the mathematics applied to fuzzy numbers, we can rewrite this problem as a standard linear problem by applying the addition rule:

\begin{center}
\includegraphics[width=.9\linewidth]{./img/FuzzyToStandardBAP.png}
\end{center}

\subsection*{FFLP Model for the Berth Allocation Problem}
\label{sec:org41f5f0f}
Using the following definitions

\begin{center}
\includegraphics[width=.9\linewidth]{./img/FFLPDef.png}
\end{center}

the BAP can be formulated assigned

\begin{center}
\includegraphics[width=.9\linewidth]{./img/FFLPFormulation.png}
\end{center}

where the \(z\) variable is similar to the \(\sigma\) variable in the PAP problem. It indicates if the vessel \(i\) is located to the left of vessel \(j\) at the berth.

Applying the methodology from the previous section, the BAP problem can be fully modeled assigned

\begin{center}
\includegraphics[width=.9\linewidth]{./img/FFLPMILP.png}
\end{center}

\section*{Sources}
\label{sec:org76114c1}
\subsection*{BAP}
\label{sec:org0cbdaee}
\begin{itemize}
\item \href{http://citeseerx.ist.psu.edu/viewdoc/download?doi=10.1.1.471.9196\&rep=rep1\&type=pdf}{The dynamic berth allocation problem for a container port}
\item \href{https://en.wikipedia.org/wiki/Berth\_allocation\_problem}{Berth allocation problem}
\item \href{https://people.orie.cornell.edu/jdai/publications/daiLinMoorthyTeo08.pdf}{Berth Allocation Planning Optimization in Container Terminals}
\item \href{https://www.comp.nus.edu.sg/\~cs5234/BAP/lecture/BAP-Lecture-CS5234.pdf}{Berth Allocation Problem – A Case Study in Algorithmic Approaches}
\item \href{https://www.researchgate.net/publication/320013147\_A\_Fully\_Fuzzy\_Linear\_Programming\_Model\_to\_the\_Berth\_Allocation\_Problem}{A Fully Fuzzy Linear Programming Model to the Berth Allocation}
\item \href{https://www.sciencedirect.com/science/article/pii/S0957417415003462}{The Continuous Berth Allocation Problem In A Container Terminal With Multiple Quays}
\end{itemize}

\subsection*{PAP}
\label{sec:orgd5fae3d}
\begin{itemize}
\item \href{https://ieeexplore.ieee.org/document/8786524}{Optimized Scheduling for Solving Position Allocation Problem in Electric Vehicle Charging Stations}
\end{itemize}
\end{document}
